%{
#include <stdio.h>
#include <stdlib.h>
%}

%union {
    int int_val;
    char *str_val;
}

%token <int_val> INTEGER
%token <str_val> IDENTIFIER
%token ADC SBC AND
%token LPAREN RPAREN COMMA

%%

// Grammar rules
program:
    instruction_list
    ;

instruction_list:
    instruction_list instruction
    | instruction
    ;

instruction:
    ADC LPAREN INTEGER RPAREN
    | SBC LPAREN INTEGER RPAREN
    | AND LPAREN INTEGER RPAREN
    ;

%%

// Error handling
void yyerror(const char *s) {
    fprintf(stderr, "Error: %s\n", s);
}

int main() {
    yyparse();
    return 0;
}
